Index: /XIOS/dev/dev_olga/src/transformation/Functions/average_reduction.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/Functions/average_reduction.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/Functions/average_reduction.cpp	(revision 1158)
@@ -3,9 +3,10 @@
    \author Ha NGUYEN
    \since 8 Sep 2016
-   \date 8 Sep 2016
+   \date 9 Jan 2017
 
    \brief average reduction
  */
 #include "average_reduction.hpp"
+#include "utils.hpp"
 
 namespace xios {
@@ -29,25 +30,56 @@
                                        const double* dataInput,
                                        CArray<double,1>& dataOut,
-                                       std::vector<bool>& flagInitial)
+                                       std::vector<bool>& flagInitial,                     
+                                       bool ignoreMissingValue)
 {
-  if (resetWeight_) { weights_.resize(flagInitial.size()); weights_ = 1.0; resetWeight_ = false; }
+  if (resetWeight_) { weights_.resize(flagInitial.size()); weights_ = 1.0; resetWeight_ = false; }  
 
-  int nbLocalIndex = localIndex.size();
-  int currentlocalIndex = 0;
-  double currentWeight  = 0.0;
-  for (int idx = 0; idx < nbLocalIndex; ++idx)
+  if (ignoreMissingValue)
   {
-    currentlocalIndex = localIndex[idx].first;
-    currentWeight     = localIndex[idx].second;
+    int nbLocalIndex = localIndex.size();
+    int currentlocalIndex = 0;
+    double currentWeight  = 0.0;
 
-    if (flagInitial[currentlocalIndex])
+    dataOut=std::numeric_limits<double>::quiet_NaN();
+
+    for (int idx = 0; idx < nbLocalIndex; ++idx)
     {
-      dataOut(currentlocalIndex) = *(dataInput + idx);
-      flagInitial[currentlocalIndex] = false;
+      currentlocalIndex = localIndex[idx].first;
+      currentWeight     = localIndex[idx].second;
+      if (!NumTraits<double>::isnan(*(dataInput + idx)))
+      {
+        if (flagInitial[currentlocalIndex])
+        {
+          dataOut(currentlocalIndex) = *(dataInput + idx);
+          flagInitial[currentlocalIndex] = false;
+        }
+        else
+        {
+          dataOut(currentlocalIndex)  += *(dataInput + idx);
+          weights_(currentlocalIndex) += 1.0;
+        }
+      }
     }
-    else
+  }
+  else
+  {
+    int nbLocalIndex = localIndex.size();
+    int currentlocalIndex = 0;
+    double currentWeight  = 0.0;
+    for (int idx = 0; idx < nbLocalIndex; ++idx)
     {
-      dataOut(currentlocalIndex)  += *(dataInput + idx);
-      weights_(currentlocalIndex) += 1.0;
+      currentlocalIndex = localIndex[idx].first;
+      currentWeight     = localIndex[idx].second;
+
+      if (flagInitial[currentlocalIndex])
+      {
+        dataOut(currentlocalIndex) = *(dataInput + idx);
+        flagInitial[currentlocalIndex] = false;
+      }
+      else
+      {
+        dataOut(currentlocalIndex)  += *(dataInput + idx);
+        weights_(currentlocalIndex) += 1.0;
+      }
     }
   }
Index: /XIOS/dev/dev_olga/src/transformation/Functions/average_reduction.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/Functions/average_reduction.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/Functions/average_reduction.hpp	(revision 1158)
@@ -26,5 +26,6 @@
                      const double* dataInput,
                      CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial);
+                     std::vector<bool>& flagInitial,                     
+                     bool ignoreMissingValue);
 
   virtual void updateData(CArray<double,1>& dataOut);
Index: /XIOS/dev/dev_olga/src/transformation/Functions/extract.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/Functions/extract.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/Functions/extract.cpp	(revision 1158)
@@ -29,5 +29,6 @@
                                        const double* dataInput,
                                        CArray<double,1>& dataOut,
-                                       std::vector<bool>& flagInitial)
+                                       std::vector<bool>& flagInitial,
+                                       bool ignoreMissingValue)
 {
   int nbLocalIndex = localIndex.size();
Index: /XIOS/dev/dev_olga/src/transformation/Functions/extract.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/Functions/extract.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/Functions/extract.hpp	(revision 1158)
@@ -26,5 +26,6 @@
                      const double* dataInput,
                      CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial);
+                     std::vector<bool>& flagInitial,
+                     bool ignoreMissingValue);
 
   virtual ~CExtractReductionAlgorithm() {}
Index: /XIOS/dev/dev_olga/src/transformation/Functions/max_reduction.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/Functions/max_reduction.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/Functions/max_reduction.cpp	(revision 1158)
@@ -8,4 +8,5 @@
  */
 #include "max_reduction.hpp"
+#include "utils.hpp"
 
 namespace xios {
@@ -29,21 +30,45 @@
                                    const double* dataInput,
                                    CArray<double,1>& dataOut,
-                                   std::vector<bool>& flagInitial)
-{
-  int nbLocalIndex = localIndex.size();
-  int currentlocalIndex = 0;
-  double currentWeight  = 0.0;
-  for (int idx = 0; idx < nbLocalIndex; ++idx)
+                                   std::vector<bool>& flagInitial,
+                                   bool ignoreMissingValue)
+{ 
+  if (ignoreMissingValue)
   {
-    currentlocalIndex = localIndex[idx].first;
-    currentWeight     = localIndex[idx].second;
-    if (flagInitial[currentlocalIndex])
+    int nbLocalIndex = localIndex.size();
+    int currentlocalIndex = 0;
+    dataOut=std::numeric_limits<double>::quiet_NaN();    
+    for (int idx = 0; idx < nbLocalIndex; ++idx)
     {
-      dataOut(currentlocalIndex) = *(dataInput + idx);
-      flagInitial[currentlocalIndex] = false;
+      currentlocalIndex = localIndex[idx].first;      
+      if (!NumTraits<double>::isnan(*(dataInput + idx)))
+      {
+        if (flagInitial[currentlocalIndex])
+        {
+          dataOut(currentlocalIndex) = *(dataInput + idx);
+          flagInitial[currentlocalIndex] = false;
+        }
+        else
+        {
+          dataOut(currentlocalIndex) = std::max(*(dataInput + idx), dataOut(currentlocalIndex));
+        }
+      }
     }
-    else
+  }
+  else
+  {
+    int nbLocalIndex = localIndex.size();
+    int currentlocalIndex = 0;    
+    for (int idx = 0; idx < nbLocalIndex; ++idx)
     {
-      dataOut(currentlocalIndex) = std::max(*(dataInput + idx), dataOut(currentlocalIndex));
+      currentlocalIndex = localIndex[idx].first;      
+      if (flagInitial[currentlocalIndex])
+      {
+        dataOut(currentlocalIndex) = *(dataInput + idx);
+        flagInitial[currentlocalIndex] = false;
+      }
+      else
+      {
+        dataOut(currentlocalIndex) = std::max(*(dataInput + idx), dataOut(currentlocalIndex));
+      }
     }
   }
Index: /XIOS/dev/dev_olga/src/transformation/Functions/max_reduction.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/Functions/max_reduction.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/Functions/max_reduction.hpp	(revision 1158)
@@ -26,5 +26,6 @@
                      const double* dataInput,
                      CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial);
+                     std::vector<bool>& flagInitial,
+                     bool ignoreMissingValue);
 
   virtual ~CMaxReductionAlgorithm() {}
Index: /XIOS/dev/dev_olga/src/transformation/Functions/min_reduction.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/Functions/min_reduction.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/Functions/min_reduction.cpp	(revision 1158)
@@ -3,9 +3,10 @@
    \author Ha NGUYEN
    \since 27 June 2016
-   \date 27 June 2016
+   \date 9 Jan 2017
 
    \brief min reduction
  */
 #include "min_reduction.hpp"
+#include "utils.hpp"
 
 namespace xios {
@@ -29,19 +30,45 @@
                                    const double* dataInput,
                                    CArray<double,1>& dataOut,
-                                   std::vector<bool>& flagInitial)
+                                   std::vector<bool>& flagInitial,
+                                   bool ignoreMissingValue)
 {
-  int nbLocalIndex = localIndex.size();
-  int currentlocalIndex = 0;
-  for (int idx = 0; idx < nbLocalIndex; ++idx)
+  if (ignoreMissingValue)
   {
-    currentlocalIndex = localIndex[idx].first;
-    if (flagInitial[currentlocalIndex])
+    int nbLocalIndex = localIndex.size();
+    int currentlocalIndex = 0;
+    dataOut=std::numeric_limits<double>::quiet_NaN();
+    for (int idx = 0; idx < nbLocalIndex; ++idx)
     {
-      dataOut(currentlocalIndex) = *(dataInput + idx);
-      flagInitial[currentlocalIndex] = false;
+      currentlocalIndex = localIndex[idx].first;
+      if (!NumTraits<double>::isnan(*(dataInput + idx)))
+      {
+        if (flagInitial[currentlocalIndex])
+        {
+          dataOut(currentlocalIndex) = *(dataInput + idx);
+          flagInitial[currentlocalIndex] = false;
+        }
+        else
+        {
+          dataOut(currentlocalIndex) = std::min(*(dataInput + idx), dataOut(currentlocalIndex));
+        }
+      }
     }
-    else
+  }
+  else
+  {
+    int nbLocalIndex = localIndex.size();
+    int currentlocalIndex = 0;
+    for (int idx = 0; idx < nbLocalIndex; ++idx)
     {
-      dataOut(currentlocalIndex) = std::min(*(dataInput + idx), dataOut(currentlocalIndex));
+      currentlocalIndex = localIndex[idx].first;
+      if (flagInitial[currentlocalIndex])
+      {
+        dataOut(currentlocalIndex) = *(dataInput + idx);
+        flagInitial[currentlocalIndex] = false;
+      }
+      else
+      {
+        dataOut(currentlocalIndex) = std::min(*(dataInput + idx), dataOut(currentlocalIndex));
+      }
     }
   }
Index: /XIOS/dev/dev_olga/src/transformation/Functions/min_reduction.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/Functions/min_reduction.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/Functions/min_reduction.hpp	(revision 1158)
@@ -26,5 +26,6 @@
                      const double* dataInput,
                      CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial);
+                     std::vector<bool>& flagInitial,                     
+                     bool ignoreMissingValue);
 
   virtual ~CMinReductionAlgorithm() {}
Index: /XIOS/dev/dev_olga/src/transformation/Functions/reduction.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/Functions/reduction.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/Functions/reduction.hpp	(revision 1158)
@@ -45,5 +45,6 @@
                      const double* dataInput,
                      CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial) = 0;
+                     std::vector<bool>& flagInitial,                     
+                     bool ignoreMissingValue) = 0;
   /*!
     Update local data 
Index: /XIOS/dev/dev_olga/src/transformation/Functions/sum_reduction.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/Functions/sum_reduction.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/Functions/sum_reduction.cpp	(revision 1158)
@@ -3,9 +3,10 @@
    \author Ha NGUYEN
    \since 27 June 2016
-   \date 27 June 2016
+   \date 9 Jan 2017
 
    \brief sum reduction
  */
 #include "sum_reduction.hpp"
+#include "utils.hpp"
 
 namespace xios {
@@ -29,21 +30,47 @@
                                    const double* dataInput,
                                    CArray<double,1>& dataOut,
-                                   std::vector<bool>& flagInitial)
+                                   std::vector<bool>& flagInitial,
+                                   bool ignoreMissingValue)
 {
-  int nbLocalIndex = localIndex.size();
-  int currentlocalIndex = 0;
-  double currentWeight  = 0.0;
-  for (int idx = 0; idx < nbLocalIndex; ++idx)
+  if (ignoreMissingValue)
   {
-    currentlocalIndex = localIndex[idx].first;
-    currentWeight     = localIndex[idx].second;
-    if (flagInitial[currentlocalIndex])
+    int nbLocalIndex = localIndex.size();
+    int currentlocalIndex = 0;
+
+    dataOut=std::numeric_limits<double>::quiet_NaN();
+  
+    for (int idx = 0; idx < nbLocalIndex; ++idx)
     {
-      dataOut(currentlocalIndex) = *(dataInput + idx);
-      flagInitial[currentlocalIndex] = false;
-    }
-    else
+      currentlocalIndex = localIndex[idx].first;   
+      if (!NumTraits<double>::isnan(*(dataInput + idx)))
+      {   
+        if (flagInitial[currentlocalIndex])
+        {
+          dataOut(currentlocalIndex) = *(dataInput + idx);
+          flagInitial[currentlocalIndex] = false;
+        }
+        else
+        {
+          dataOut(currentlocalIndex) += *(dataInput + idx);
+        }
+      }
+    }    
+  }
+  else
+  {
+    int nbLocalIndex = localIndex.size();
+    int currentlocalIndex = 0;    
+    for (int idx = 0; idx < nbLocalIndex; ++idx)
     {
-      dataOut(currentlocalIndex) += *(dataInput + idx);
+      currentlocalIndex = localIndex[idx].first;      
+      if (flagInitial[currentlocalIndex])
+      {
+        dataOut(currentlocalIndex) = *(dataInput + idx);
+        flagInitial[currentlocalIndex] = false;
+      }
+      else
+      {
+        dataOut(currentlocalIndex) += *(dataInput + idx);
+      }
     }
   }
Index: /XIOS/dev/dev_olga/src/transformation/Functions/sum_reduction.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/Functions/sum_reduction.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/Functions/sum_reduction.hpp	(revision 1158)
@@ -26,5 +26,6 @@
                      const double* dataInput,
                      CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial);
+                     std::vector<bool>& flagInitial,
+                     bool ignoreMissingValue);
 
   virtual ~CSumReductionAlgorithm() {}
Index: /XIOS/dev/dev_olga/src/transformation/axis_algorithm_extract_domain.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/axis_algorithm_extract_domain.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/axis_algorithm_extract_domain.cpp	(revision 1158)
@@ -68,8 +68,8 @@
                                         const double* dataInput,
                                         CArray<double,1>& dataOut,
-                                        std::vector<bool>& flagInitial,
-                                        const double& defaultValue)
+                                        std::vector<bool>& flagInitial,                     
+                                        bool ignoreMissingValue)
 {
-  reduction_->apply(localIndex, dataInput, dataOut, flagInitial);
+  reduction_->apply(localIndex, dataInput, dataOut, flagInitial, ignoreMissingValue);
 }
 
Index: /XIOS/dev/dev_olga/src/transformation/axis_algorithm_extract_domain.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/axis_algorithm_extract_domain.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/axis_algorithm_extract_domain.hpp	(revision 1158)
@@ -33,6 +33,6 @@
                      const double* dataInput,
                      CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial,
-                     const double& defaultValue);
+                     std::vector<bool>& flagInitial,                     
+                     bool ignoreMissingValue);
 
   virtual ~CAxisAlgorithmExtractDomain();
Index: /XIOS/dev/dev_olga/src/transformation/axis_algorithm_reduce_domain.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/axis_algorithm_reduce_domain.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/axis_algorithm_reduce_domain.cpp	(revision 1158)
@@ -76,8 +76,8 @@
                                        const double* dataInput,
                                        CArray<double,1>& dataOut,
-                                       std::vector<bool>& flagInitial,
-                                       const double& defaultValue)
+                                       std::vector<bool>& flagInitial,                     
+                                       bool ignoreMissingValue)
 {
-  reduction_->apply(localIndex, dataInput, dataOut, flagInitial);
+  reduction_->apply(localIndex, dataInput, dataOut, flagInitial, ignoreMissingValue);
 }
 
Index: /XIOS/dev/dev_olga/src/transformation/axis_algorithm_reduce_domain.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/axis_algorithm_reduce_domain.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/axis_algorithm_reduce_domain.hpp	(revision 1158)
@@ -32,6 +32,6 @@
                      const double* dataInput,
                      CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial,
-                     const double& defaultValue);
+                     std::vector<bool>& flagInitial,                     
+                     bool ignoreMissingValue);
 
   virtual void updateData(CArray<double,1>& dataOut);
